#ifndef _CBASICCAMERA_H_
#define _CBASICCAMERA_H_


#include "CCamera.h"

class CGameObject;

class CBasicCamera : public CCamera
{
protected:
	CGameObject*	m_TargetObject;

private:

	CBasicCamera(const CBasicCamera&);
	CBasicCamera &operator = (const CBasicCamera&);

public:

	CBasicCamera();
	CBasicCamera(const string& cameraName);
	CBasicCamera(const string& cameraName, const D3DXVECTOR3& startPosition);
	CBasicCamera(const string& cameraName, const D3DXVECTOR3& startPosition, const D3DXVECTOR3& startLookAt);
	CBasicCamera(const string& cameraName, const D3DXVECTOR3& startPosition, CGameObject* startTarget);
	~CBasicCamera();

	void BuildPerspective(float fieldOfView, float aspectRatio, float nearZ, float farZ);
	void NormalizeViewMatrix(void);
	void Update(void);

	// Movement
	// Move forward distance indicated, negative moves backwards
	void Dolly(float distance);
	// Move side to side positive = right, negative = left
	void Strafe(float distance);
	// CHANGE TITLE
	// Move up and down, positive = up, negative = down
	void MoveUp(float distance);

	//
	void Yaw(float radians);
	//
	void Pitch(float radians);
	//
	void Roll(float radians);

	// Accessors

	// Mutators
	void SetPosition(D3DXVECTOR3* position);
	void SetLookAtTarget(D3DXVECTOR3* lookAt);
};

#endif