#include "CMovableCamera.h"
#include "CInputManager.h"
#include "CGameManager.h"

CMovableCamera::CMovableCamera()
{
}

CMovableCamera::CMovableCamera(const string& cameraName) : CBasicCamera(cameraName)
{
}

CMovableCamera::CMovableCamera(const string& cameraName, const D3DXVECTOR3& startPosition) :
CBasicCamera(cameraName, startPosition)
{
}

CMovableCamera::CMovableCamera(const string& cameraName, const D3DXVECTOR3& startPosition, const D3DXVECTOR3& startLookAt) :
CBasicCamera(cameraName, startPosition, startLookAt)
{
}

CMovableCamera::CMovableCamera(const string& cameraName, const D3DXVECTOR3& startPosition, CGameObject* startTarget) :
CBasicCamera(cameraName, startPosition, startTarget)
{
}

CMovableCamera::~CMovableCamera()
{
	
}

void CMovableCamera::Update(void)
{
	float elapsedTime = GameManager().Timer().GetDeltaTime();
	float cameraSpeed = 325.0f;

	LONG xDelta = InputManager().Mouse().GetMouseAxis(XAXIS);
	LONG yDelta = InputManager().Mouse().GetMouseAxis(YAXIS);

	if (InputManager().Mouse().GetMouseButton(0))
	{
		Yaw( xDelta * elapsedTime * 1.8f);
		Pitch( yDelta * elapsedTime * 1.8f );
	}
	/*if ( pMouseButtons[0] )
	{
		m_camera.Yaw( xDelta * elapsedTime * 1.8f);
		m_camera.Pitch( yDelta * elapsedTime * 1.8f );

	}*/

	if ( InputManager().Keyboard().GetKey(DIK_UPARROW) )
	{
		Dolly( cameraSpeed * elapsedTime );

	}
	if ( InputManager().Keyboard().GetKey(DIK_LEFTARROW) )
	{
		Strafe( -cameraSpeed * elapsedTime );

	}
	if ( InputManager().Keyboard().GetKey(DIK_DOWNARROW) )
	{
		Dolly( -cameraSpeed * elapsedTime );

	}
	if ( InputManager().Keyboard().GetKey(DIK_RIGHTARROW) )
	{
		Strafe( cameraSpeed * elapsedTime );

	}

	CBasicCamera::Update();
}