#include "CPixelShader.h"
#include "CDirect3D.h"

CShader& CPixelShader::Create(string shaderName, string shaderFileName, string shaderEntryPoint, string shaderVersion)
{
	HRESULT hr;

	hr = D3DXCompileShaderFromFile(
		shaderFileName.c_str(),
		0,
		0,
		shaderEntryPoint.c_str(),
		shaderVersion.c_str(),
		D3DXSHADER_DEBUG,
		&m_pShader,
		&m_pErrorBuffer,
		&m_pConstantTable);

	if (m_pErrorBuffer)
	{
		m_pErrorBuffer->Release();
	}

	if (FAILED(hr))
	{
		return CPixelShader();
	}

	m_pDevice = Direct3D().GetDirect3DDevice();

	m_pDevice->CreatePixelShader((DWORD*)m_pShader->GetBufferPointer(), &m_PixelShader);

	return *this;
}

bool CPixelShader::Release()
{
	m_PixelShader->Release();

	return true;
}

bool CPixelShader::SetShader()
{
	m_pDevice->SetPixelShader(m_PixelShader);

	return true;
}