#ifndef _CSHADERMANAGER_H_
#define _CSHADERMANAGER_H_

#include <string>
using std::string;

#include <map>
using std::map;

class CShader;

enum ShaderType {PIXEL_SHADER, VERTEX_SHADER, MAX_SHADER_TYPES};

class CShaderManager
{
protected:

	map<string, CShader*> m_ShaderMap;

private:

	CShaderManager();
	CShaderManager(const CShaderManager & );
	CShaderManager & operator = (const CShaderManager& );

public:

	~CShaderManager();

	static CShaderManager &GetInstance();

	void Init();
	void Shutdown();

	bool LoadShader(int shaderType, string shaderName, string shaderFileName, string shaderEntryPoint, string shaderVersion);
	bool UnLoadShader(string shaderName, string shaderFileName);

	CShader& GetShader(string shaderName);
};

static CShaderManager &ShaderManager()
{
	return CShaderManager::GetInstance();
}

#endif