#ifndef _CTRIGGERMANAGER_H_
#define _CTRIGGERMANAGER_H_

#include "Constants.h"

#include "CTrigger.h"

#include <string>
using std::string;

#include <map>
using std::map;

#include <vector>
using std::vector;

enum TRIGGER_TYPE
{
	TRIGGER_SET_CAMERA_POSITION = 0,
	TRIGGER_SWITCH_ACTIVE_CAMERA,
	TRIGGER_BOOST_RAIL,
	TRIGGER_HUD_SIGN,
	TRIGGER_RAIL_APPROACH,
};

enum TRIGGER_SHUTDOWN_TYPE
{
	SHUTDOWN_DISTANCE = 0,
	SHUTDOWN_TIME,
};

//class cTrigger;

class CTriggerManager
{
protected:
	
	vector<cTrigger*> m_vTriggers;

public:
	float		m_fDefaultOffsetX;
	float		m_fDefaultOffsetY;
	float		m_fDefaultOffsetZ;
	float		m_fDefaultLookAtX;
	float		m_fDefaultLookAtY;
	float		m_fDefaultLookAtZ;

	float		m_fAboveCar1OffsetX;
	float		m_fAboveCar1OffsetY;
	float		m_fAboveCar1OffsetZ;
	float		m_fAboveCar1LookAtX;
	float		m_fAboveCar1LookAtY;
	float		m_fAboveCar1LookAtZ;

	float		m_fAboveCar2OffsetX;
	float		m_fAboveCar2OffsetY;
	float		m_fAboveCar2OffsetZ;
	float		m_fAboveCar2LookAtX;
	float		m_fAboveCar2LookAtY;
	float		m_fAboveCar2LookAtZ;

	float		m_fApproachingRingOffsetX;
	float		m_fApproachingRingOffsetY;
	float		m_fApproachingRingOffsetZ;
	float		m_fApproachingRingLookAtX;
	float		m_fApproachingRingLookAtY;
	float		m_fApproachingRingLookAtZ;

	float		m_fOnBoostRingOffsetX;
	float		m_fOnBoostRingOffsetY;
	float		m_fOnBoostRingOffsetZ;
	float		m_fOnBoostRingLookAtX;
	float		m_fOnBoostRingLookAtY;
	float		m_fOnBoostRingLookAtZ;

private:

	CTriggerManager();
	CTriggerManager(const CTriggerManager & );
	CTriggerManager & operator = (const CTriggerManager& );


public:

	~CTriggerManager();

	static CTriggerManager &GetInstance();

	void Init();
	void Update();
	void Shutdown();

	void LoadTriggerDefinitions();
	void LoadTriggers();
};

static CTriggerManager &TriggerManager()
{
	return CTriggerManager::GetInstance();
}

#endif